% Include command for new chapters.
% Optionally, it is possible
\newcommand{\incchapter}[2][]{
  \chapter{#2}
  \ifthenelse{\equal{#1}{}}%
    {}%
    {\input{chapters/#1.tex}}%
}


% Analogous include command for sections and subsections.
\newcommand{\incsection}[2][]{
  \section{#2}
  \ifthenelse{\equal{#1}{}}%
    {}%
    {\input{chapters/#1.tex}}%
}

\newcommand{\incsubsection}[2][]{
  \subsection{#2}
  \ifthenelse{\equal{#1}{}}%
    {}%
    {\input{chapters/#1.tex}}%
}


% Outline macro. Used to describe upcoming steps.
\newenvironment{outline}{
  \color{darkgreen}
}{}


% Semicomment macro. Used to make paragraphs grey.
\newenvironment{semicomment}{
  \color{gray}
}{}


% Shorthand for a command for temporary texts that is not too aggressive in color.
\newcommand{\temp}[1]{\textcolor{blue}{#1}}


% Marker command. May indicate last point of work.
\newcommand{\marker}{\mbox{\textcolor{red}{\textbf{[MARKER IS HERE]}}}}


% Just a hacky fat bar. I like it especially because of its hackkyness.
\newcommand{\myhrule}{ 
  \vspace{0.5\baselineskip}
  \TK{\hrule}
  \TK{\hrule}
  \TK{\hrule}
  \TK{\hrule}
  \TK{\hrule}
  \vspace{0.5\baselineskip}
}

% Side nodes.
\newcommand{\snote}[1]{
  \TK[#1]{}
}

% Arbitrary vspace.
\newcommand{\myskip}{\vspace{2\baselineskip}}

% Image of a map.
%~ \newcommand{\im}{\operatorname{im}}

% Names.
\newcommand{\Gauss}{Gau{\ss}}

% Energy names.
\newcommand{\ECH}{J_{\text{CH}}} % Energy Canham-Helfrich
\newcommand{\EWill}{J_{\text{Will}}} % Energy Canham-Helfrich
\newcommand{\EMG}{J_{\text{MG}}} % Energy Monge-gauge
\newcommand{\EL}{J} % Energy Monge-gauge linearized
\newcommand{\EPhi}{J_{\varphi}} % Parameterized energy.
\newcommand{\ELin}{J_{\text{lin}}} % Linearized energy.
\newcommand{\EF}{J_f} % Forcing energy.
\newcommand{\EMP}{J_{mp}} % Membrane particle interaction.
\newcommand{\EP}{J_p} % Particle-particle interaction energy.
\newcommand{\EI}{\cE} % Interaction energy.
\newcommand{\E}{J} % Generic energy.
\newcommand{\Eloc}{\wt{\E}} % Local energy (used in differentiability section).

% Hausdorff measure.
\newcommand{\HM}{\mathbb{H}(\cM)}
\newcommand{\HMn}{\mathbb{H}(\cM_0)}
\newcommand{\HG}{\mathbb{H}(\Gamma)}

% Space time tube.
\newcommand{\MT}{\cM_T}

% Particle configuration.
\newcommand{\p}{\textbf{p}}
\newcommand{\q}{\textbf{q}} % Element in tangential configuration space

% Admissible membrane set.
\newcommand{\Uad}{U_{\text{ad}}}

% Trace operator.
%~ \newcommand{\T}{T}

% Restriction operator.
\newcommand{\Rs}{R}

% Projection operator.
\renewcommand{\P}{P}

% Span of a space.
\newcommand{\spn}{\operatorname{span}}

% (Temporarily useful:) Shorthand for geometric computations.
%~ \newcommand{\ux}{\partial_1 u}
%~ \newcommand{\uy}{\partial_2 u}
%~ \newcommand{\uxx}{\partial_{11} u}
%~ \newcommand{\uxy}{\partial_{12} u}
%~ \newcommand{\uyx}{\partial_{21} u}
%~ \newcommand{\uyy}{\partial_{22} u}
\newcommand{\ux}{u_1}
\newcommand{\uy}{u_2}
\newcommand{\uxx}{u_{11}}
\newcommand{\uxy}{u_{12}}
\newcommand{\uyx}{u_{21}}
\newcommand{\uyy}{u_{22}}
\newcommand{\cx}{c_x}
\newcommand{\sx}{s_x}
\newcommand{\cy}{c_y}
\newcommand{\sy}{s_y}

% First and second fundamental forms.
\newcommand{\I}{\textup{\uppercase\expandafter{\romannumeral 1}}}
\newcommand{\II}{\textup{\uppercase\expandafter{\romannumeral 2}}}

% Differentiation macros used in linearization part.
\newcommand{\dtf}[1]{\left. \frac{\partial}{\partial t} #1 \right|_{t = 0}}
\newcommand{\dtfn}[2]{\left. \frac{\partial^{#2}}{\partial t^{#2}} #1 \right|_{t = 0}}
\newcommand{\dmat}{\dot{\partial}}
\newcommand{\Dsurf}{D_{\cM(t)}}
\newcommand{\gsurf}{\nabla_{\cM(t)}}
\newcommand{\divsurf}{\div_{\cM(t)}}

\newcommand{\dmatn}[1]{\left.\dot{\partial} #1 \right|_{t=0}}
\newcommand{\Dsurfn}{D_{\cM_0}}
\newcommand{\gsurfn}{\nabla_{\cM_0}}
\newcommand{\Deltasurfn}{\Delta_{\cM_0}}
\newcommand{\Deltasurf}{\Delta_{\cM}}
\newcommand{\divsurfn}{\div_{\cM(0)}}

\newcommand{\dH}{\d{\mathbb{H}}}

% "Upside down lowercase pi"
%~ \newcommand{\copi}{\mathrel{\raisebox{0pt}{\scaleobj{1.0}{\rotatebox[origin=c]{180}{$\Pi$}}}}}
\newcommand{\copi}{\raisebox{-0.25pt}{$\amalg$}}

% Operators for "subset evaluation"
\newcommand{\Tres}{T_{\text{res}}}
\newcommand{\Trace}{T_{\text{tra}}}
\newcommand{\Teval}{T_{\text{eval}}}

% Commands for the differentiability section.
\newcommand{\hatT}{{T}} % ...
\newcommand{\hatg}{{g}} % ...
\newcommand{\X}{\cX}  % p-dependent domain diffeomorphism
%~ \newcommand{\id}{\operatorname{id}} % Identity operator
\newcommand{\dpn}[1]{\left. \dd{\p} #1 \right|_{\p=\p^0}}


% Discretization.
\renewcommand{\S}{\cS}
\newcommand{\Sad}{\S_{\text{ad}}}
\newcommand{\aNit}{a_{\text{Nit}}}
\newcommand{\aPen}{a_{\text{pen}}}
\newcommand{\aStab}{a_{\text{stab}}}
\newcommand{\ah}{a_h}
\newcommand{\trinorm}[1]{\vertiii{#1}}
\newcommand{\lPen}{\ell_{\text{pen}}}
\newcommand{\lNit}{\ell_{\text{Nit}}}
\newcommand{\Hpw}{H_{\cT}}
\newcommand{\jmp}[1]{\left\llbracket #1 \right\rrbracket}
\newcommand{\uh}{u_h}
\newcommand{\Iu}{\overline{u}}
\newcommand{\aOmega}{a_{\Omega_0}}
\newcommand{\Ie}{\overline{e}}
\newcommand{\nastyidx}{\substack{\abs{\alpha}\leq 3, \abs{\beta}\leq 1 \\ \abs{\alpha} + \abs{\beta} \leq 3}}
\newcommand{\du}{\textbf{u}} % Discrete u
\newcommand{\dv}{\textbf{v}} % Discrete v

% Assumption boxes.
\crefname{asp}{Assumption}{Assumptions}
\newcounter{discAssumption}
\newcommand{\dasp}[1]{\stepcounter{discAssumption}\label[asp]{#1}\tag{A\thediscAssumption}}
\newsavebox\ideabox
\newenvironment{asp}[1]
  {
   \begin{equation}
    \dasp{#1}
   \begin{lrbox}{\ideabox}
   \begin{minipage}{\dimexpr\columnwidth-2\leftmargini}
   \setlength{\leftmargini}{0pt}%
   \begin{quote}}
  {\end{quote}
   \end{minipage}
   \end{lrbox}\makebox[0pt]{\usebox{\ideabox}}
   \end{equation}}

% Experiments
\newcommand{\incsvg}[2]{\centering\def\svgwidth{#1}\input{./gfx/#2.pdf_tex}}


% Application part
\newcommand{\angstrom}{\ensuremath{\textup{\AA}}}


% Outlook.
\newcommand{\vel}{\textbf{v}}
\newcommand{\Ekin}{E_{\text{kin}}}
\newcommand{\TD}{\mathrm{T}\cD}
\newcommand{\EXP}{\mathbb{E}}




%~ % Remove trailing dots. Cf. https://tex.stackexchange.com/questions/202928/remove-last-dot-in-title-numbering
%~ \makeatletter
%~ \g@addto@macro{\appendix}{%
  %~ \patchcmd{\@@makechapterhead}% <cmd>
    %~ {\endgraf\nobreak\vskip.5\baselineskip}% <search>
    %~ {\hspace*{-.5em}:\space}% <replace>
    %~ {}{}% <success><failure>
  %~ \patchcmd{\@chapter}% <cmd>
    %~ {\addchaptertocentry{\thechapter}}% <search>
    %~ {\addchaptertocentry{Appendix~\thechapter:}}% <replace>
    %~ {}{}% <success><failure>
  %~ \addtocontents{toc}{%
    %~ \protect\patchcmd{\protect\l@chapter}% <cmd>
      %~ {1.5em}% <search>
      %~ {6.5em}% <replace>
      %~ {}{}}% <success><failure>
%~ }
%~ \renewcommand{\autodot}{}% Remove all end-of-counter dots
%~ \makeatother


% Modify hyperref style.
% See https://tex.stackexchange.com/questions/47713/underlined-links-with-hyperref-possible
\hypersetup{
    pdfborderstyle={/S/U/W 1}, % underline links instead of boxes
    linkbordercolor=red,       % color of internal links
    citebordercolor=green,     % color of links to bibliography
    filebordercolor=magenta,   % color of file links
    urlbordercolor=cyan        % color of external links
}



% Make refcheck aware of cleveref.
% See: https://tex.stackexchange.com/questions/87610/making-refcheck-work-with-cleveref
%~ \makeatletter
%~ \newcommand{\refcheckize}[1]{%
  %~ \expandafter\let\csname @@\string#1\endcsname#1%
  %~ \expandafter\DeclareRobustCommand\csname relax\string#1\endcsname[1]{%
    %~ \csname @@\string#1\endcsname{##1}\wrtusdrf{##1}}%
  %~ \expandafter\let\expandafter#1\csname relax\string#1\endcsname
%~ }
%~ \newcommand{\refcheckizetwo}[1]{%
  %~ \expandafter\let\csname @@\string#1\endcsname#1%
  %~ \expandafter\DeclareRobustCommand\csname relax\string#1\endcsname[2]{%
    %~ \csname @@\string#1\endcsname{##1}{##2}\wrtusdrf{##1}\wrtusdrf{{##1}}\wrtusdrf{##2}\wrtusdrf{{##2}}}%
  %~ \expandafter\let\expandafter#1\csname relax\string#1\endcsname
%~ }
%~ \makeatother

%~ \refcheckize{\cref}
%~ \refcheckize{\Cref}
%~ \refcheckizetwo{\crefrange}
%~ \refcheckizetwo{\Crefrange}
